﻿using Lidgren.Network;

namespace Jazz2.Networking.Packets.Server
{
    public struct PlayerSetInvulnerability : IServerPacket
    {
        public NetConnection SenderConnection { get; set; }

        byte IServerPacket.Type => 29;


        public byte Index;
        public float Time;
        public bool WithCircleEffect;

        void IServerPacket.Read(NetIncomingMessage msg)
        {
            Index = msg.ReadByte();

            Time = msg.ReadSingle();
            WithCircleEffect = msg.ReadBoolean();
        }

        void IServerPacket.Write(NetOutgoingMessage msg)
        {
            msg.Write((byte)Index);

            msg.Write((float)Time);
            msg.Write((bool)WithCircleEffect);
        }
    }
}